module encrypt(indata, clk, LoadD, subkey, mode, dout, round, Dready);

/***********************INPUTS*******************************/
input [0:63] indata;  // 64 bit plain text input
input [47:0] subkey;  // Rounds Subkeys input
input clk;            // Clock input
input LoadD;          // Loads the data
input mode;           // mode = 0 or 1 for encrpytion or decryption respectively

/**********************OUTPUTS******************************/
output [63:0] dout;   // 64 bit cipher text output 
output [4:0] round;   // Round number used for subkey selection
output Dready;        // Indicates that output is valid

/*********************REGISTERED OUTPUTS********************/
reg [4:0] round;
reg Dready;

/*********************LOCAL VARIABLES***********************/
reg [31:0] left, right;
reg [4:0] index;
wire [31:0] b, rightbar, pout;
wire [47:0] xor1, expout;
 
 always@(posedge clk)
 begin
  if(LoadD)
  begin
         

         
        
        if(!mode)
          round <= 0;
        else
          round <= 15;
        index <= 0;  
        Dready <= 0;                                              
   end 
   
   else if(index==0)
   begin
        left <={indata[57],indata[49],indata[41],indata[33],indata[25],
                indata[17],indata[9],indata[1],indata[59],indata[51],
                indata[43],indata[35],indata[27],indata[19],indata[11],
                indata[3],indata[61],indata[53],indata[45],indata[37],
                indata[29],indata[21],indata[13],indata[6],indata[63],
                indata[55],indata[47],indata[39],indata[31],indata[23],
                indata[15],indata[7]};  

         right <={indata[56],indata[48],indata[40],indata[32],indata[24],
               indata[16],indata[8],indata[0],indata[58],indata[50],
               indata[42],indata[34],indata[26],indata[18],indata[10],
               indata[2],indata[60],indata[52],indata[44],indata[36],
               indata[28],indata[20],indata[12],indata[4],indata[62],
               indata[54],indata[46],indata[38],indata[30],indata[22],
               indata[14],indata[6]};
index <= index + 1;
if(!mode)
          round <= round + 1;
       else
         round <= round - 1;

  end
   else if(index < 16)
    begin
    left <= right;
    right <= rightbar;
    index <= index + 1;    
        if(!mode)
          round <= round + 1;
        else
          round <= round - 1;
    end
   else if(index == 16)
    begin
    left <= right;
    right <= rightbar;
    index <= index + 1;
    end
   else if(index == 17)
    begin
    left <= right;
    right <= left;
    Dready <=  1;
    round <= 5'bz;
    index <= index + 1;
   end
  end
  
 expermute ep(right, expout); 
 
 assign xor1 = expout ^ subkey;
 
 s8box s8(b[3:0], xor1[5:0]);
 s7box s7(b[7:4], xor1[11:6]);
 s6box s6(b[11:8],xor1[17:12]);
 s5box s5(b[15:12],xor1[23:18]);
 s4box s4(b[19:16],xor1[29:24]);
 s3box s3(b[23:20],xor1[35:30]);
 s2box s2(b[27:24],xor1[41:36]);
 s1box s1(b[31:28],xor1[47:42]);
 permuteb pb(pout, b);
 
 assign rightbar = pout ^ left;

 fpermute fp(dout,{left,right});
 
endmodule
