/*********************************************************************************
* Copyright (c) 1996-2000 Altera Corporation.  All rights reserved.  This text     *
* contains proprietary, confidential information of Altera Corporation, and      *
* may be used, copied, and/or disclosed only pursuant to the terms of a          *
* valid software license agreement with Altera Corporation.  This copyright     *
* notice must be retained as part of this text at all times.                     *
* Model generated by Genmem Version 2.9, on Wed Oct 03 23:21:23 2001
*********************************************************************************/
// synopsys translate_off
`delay_mode_path
// synopsys translate_on
`timescale 1ns / 1ns
`celldefine
module syn_ram_16x48_idou (Q, Data, WE, Address, Inclock);

parameter LPM_FILE = "UNUSED";
parameter Width = 48;
parameter WidthAd = 4;
parameter NumWords = 16;

input [WidthAd-1:0] Address;
input [Width-1:0] Data;
input WE;
output [Width-1:0] Q;
input Inclock;


// synopsys translate_off
// internal reg
reg [Width-1:0] mem_data [NumWords-1:0];
reg [Width-1:0] tmp_q, tmp_q_reg;
reg [Width-1:0] ZERO, UNKNOWN, HiZ;
reg [8*256:1] mem_initf;
reg [WidthAd-1:0] clocked_address;
reg [Width-1:0] clocked_data;

integer i;

function ValidAddress;
    input [WidthAd-1:0] Address;
    begin
        ValidAddress = 1'b0;
        if(^Address ==='bx)
              $display("%d:Error: Invalid address", $time);
        else if(Address >= NumWords)
              $display("%d:Error: Address out of bounds on RAM", $time);
        else
              ValidAddress = 1'b1;
    end
endfunction

initial
begin

  // check for number of words out of bound
   if(NumWords > (1 << WidthAd))
         $display("Error: Too many words defined");

   for (i=0; i < Width; i=i+1)
      begin
          ZERO[i] = 1'b0;
          UNKNOWN[i] = 1'bX;
      end

   for(i = 0; i < NumWords; i=i+1)
         mem_data[i] = ZERO;

  // load data to the RAM
   if (LPM_FILE != "UNUSED")
      begin
        //   $convert_hex2ver(LPM_FILE, Width, mem_initf);
       //    $readmemh(mem_initf, mem_data);
      end
end

initial
begin

   clocked_data = 0;
   tmp_q = 0;

end

  always @( posedge Inclock)
     begin 
         clocked_data <= Data;
     end

  always @( WE or Address or clocked_data)
     begin
               if (WE)
                   begin
                      mem_data[Address] <= clocked_data;
                   end
     end

  assign Q = mem_data[Address];

// synopsys translate_on
endmodule // syn_ram_16x48_idou
`endcelldefine
