/*-----------------------------------

	NBS DES Data Encryption Standard

	DEMO HARNESS FOR LICENSE RELEASE
	Uses NBS validation file to
	demonstrate code calling syntax
	and prove implementation validity

	(C) 1989,1995 Simon J Shepherd
	(C) 1995 Cypher Systems Research
	All rights reserved

-----------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#define ENCIPHER	0
#define DECIPHER	1

extern void des_init (char *keyblock, int direction, char *workspace);
extern int des_block (char *datablock);

void main (void)
{
	FILE	*datafile;
	char	string[100],
			temp_str[3],
			keyblock[8],
			datablock[8],
			testblock[8],
			*workspace,*sp;
	int   i,j,k,n,direction;

	if ((datafile = fopen ("validate.dat", "r")) == NULL)
		{
		printf ("Cannot open file VALIDATE.DAT\n");
		exit(1);
		}

	if ((workspace = malloc (16384)) == NULL)
		{
		printf ("Cannot allocate memory for workspace\n");
		exit(1);
		}

	direction = ENCIPHER;

	for (n=0;;++n)
		{
		if (NULL == fgets (string, 95, datafile))
			break;
		sp = string;
		while (*sp >= 0x20)
			++sp;
		*sp = 0x00;

		printf ("%s\n", string);
		if (string[0] == 0x00 || string[0] == '!')
			continue;
		if (strncmp (string, "encipher", 6) == 0)
			{
			direction = ENCIPHER;
			continue;
			}
		if (strncmp (string, "decipher", 6) == 0)
			{
			direction = DECIPHER;
			continue;
			}

		j = 0;
		for (i=0;i<8;++i)
			{
			temp_str[0] = string[j++];
			temp_str[1] = string[j++];
			temp_str[2] = 0x00;
			sscanf (temp_str, "%02x", &k);
			keyblock[i] = 0x00ff & k;
			printf ("%02x", 0x00ff & (int) keyblock[i]);
			}
		++j;
		printf (" ");
		for (i=0;i<8;++i)
			{
			temp_str[0] = string[j++];
			temp_str[1] = string[j++];
			temp_str[2] = 0x00;
			sscanf (temp_str, "%02x", &k);
			datablock[i] = 0x00ff & k;
			printf ("%02x", 0x00ff & (int) datablock[i]);
			}
		++j;
		printf (" ");
		for (i=0;i<8;++i)
			{
			temp_str[0] = string[j++];
			temp_str[1] = string[j++];
			temp_str[2] = 0x00;
			sscanf (temp_str, "%02x", &k);
			testblock[i] = 0x00ff & k;
			}

		des_init (keyblock, direction, workspace);
		des_block (datablock);

		j = 0;
		for (i=0;i<8;++i)
			{
			printf ("%02x", 0x00ff & (int) datablock[i]);
			if (datablock[i] != testblock[i])
				j = 1;
			}

		if (j == 0)
			printf (" VERIFY OK\n");
		else
			printf (" FAIL\007\n");
		}

	fclose (datafile);
}

/*----------------------------- END OF SOURCE -------------------------------*/
